#
# crash core analysis suite
#
Summary: crash utility for live systems; netdump, diskdump, kdump, LKCD or mcore dumpfiles
Name: crash
Version: 4.0
Release: 7.2.3.1%{?dist}
License: GPL
Group: Development/Debuggers
Source: %{name}-%{version}.tar.gz
URL: http://people.redhat.com/anderson
ExclusiveOS: Linux
ExclusiveArch: i386 ia64 x86_64 ppc64 s390 s390x
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: ncurses-devel zlib-devel
Requires: binutils
Patch0: crash.patch
Patch1: x86-bt-interrupt-frame.patch
Patch2: ia64-search-k.patch
Patch10: crash-asianux.patch

%description
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump packages, the mcore kernel patch
or the LKCD kernel patch.

%package devel
Requires: %{name} = %{version}, zlib-devel
Summary: crash utility for live systems; netdump, diskdump, kdump, LKCD or mcore dumpfiles
Group: Development/Debuggers

%description devel
The core analysis suite is a self-contained tool that can be used to
investigate either live systems, kernel core dumps created from the
netdump, diskdump and kdump packages, the mcore kernel patch
or the LKCD kernel patch.

%prep
%setup -n %{name}-%{version}
%patch0 -p1 -b crash.patch
%patch1 -p1 -b x86-bt-interrupt-frame.patch
%patch2 -p1 -b ia64-search-k.patch
%patch10 -p1 -b asianux

%build
make RPMPKG="%{version}-%{release}"

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/bin
make DESTDIR=%{buildroot} install
mkdir -p %{buildroot}%{_mandir}/man8
cp crash.8 %{buildroot}%{_mandir}/man8/crash.8
mkdir -p %{buildroot}%{_includedir}/crash
chmod 0644 defs.h
cp defs.h %{buildroot}%{_includedir}/crash

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/bin/crash
%{_mandir}/man8/crash.8*
%doc README COPYING

%files devel
%defattr(-,root,root)
%{_includedir}/*

%changelog
* Tue Feb 17 2009 Masayuki MORIYAMA <moriyama@miraclelinux.com> - 4.0-7.2.3.1%{?dist}
- Add COPYING file
- applied patch10: Fix search path for asianux (AX#2837)
- removed some words from description

* Thu Sep 25 2008 Dave Anderson <anderson@redhat.com> - 4.0-7.2.3
  Fix for the incomplete resolution for the "search -k" option when 
  run on RHEL5 ia64 CONFIG_SPARSEMEM kernels.  The initial fix
  addressed the segmentation violation, but on certain physical 
  memory configurations, it would prematurely bail out when making
  the transition from the kernel mapped region to the vmalloc region.
- Resolves: rhbz#458417

* Tue Sep 23 2008 Dave Anderson <anderson@redhat.com> - 4.0-7.2.2
  Fix for x86 "bt" command to correctly handle the transition from
  the hard IRQ stack back to the process stack and then display
  the interrupt exception frame.
- Resolves: rhbz#462624

* Mon Sep 15 2008 Dave Anderson <anderson@redhat.com> - 4.0-7.2.1
- Fix to prevent a potential divide-by-zero SIGFPE exception when 
  using a vmlinux that does not match the vmcore being analyzed.  
  This is a bad, but acceptable, practice, although when done, it
  usually requires adding a System.map file to the command line 
  so that the correct symbol values are used; that was not done
  in this case.  
- Resolves: rhbz#457371  
- Fix for the crash utility's "search -u" option, which searches 
  the current context's user virtual address space for a given value.
  It would cause a SIGSEGV when run on a xen-syms hypervisor binary, 
  and gives a somewhat misleading error message when run on vmlinux 
  binary on a kernel thread.  Both of these usages are nonsensical 
  because the xen-syms hypervisor and vmlinux kernel threads do not 
  have user address space regions.  Fix for the "search -k" option, 
  which searches the kernel virtual address space for a given value. 
  When run on a xen-syms hypervisor binary, it would display a 
  nonsensical vmlinux-based error message.  That option should not 
  be used with the xen-syms hypervisor, which requires that a starting
  virtual address be supplied.  The fix now displays error messages 
  that are applicable to the incorrect command usage.
- Resolves: rhbz#457373
  Fix for the "search -k" option when run on RHEL5 ia64 CONFIG_SPARSEMEM
  kernels.  It would cause a segmentation violation, because it would 
  start the search at the base of the ia64 processor's identity-mapped 
  region, which is not necessarily backed by physical memory, and result
  in a SIGSEGV.  The fix sets the start of the ia64 kernel virtual address
  space search to the appropriate virtual address. 
- Resolves: rhbz#458417
  Enhancement for invoking crash with an input-file of crash commands 
  using the -i command-line option, as in "crash -i <input-file> ...", 
  and doing so from inside a script file instead of the command line.
  It would indicates "crash: /dev/tty: No such device or address", run 
  the commands in the input-file, but then would hang.  The fix terminates
  the crash session after all of the commands in the input-file have 
  completed.
- Resolves: rhbz#458422

* Fri Apr 25 2008 Dave Anderson <anderson@redhat.com> - 4.0-5.0.3
- Fixes for xen 5.2 hypervisor support.
- Resolves: rhbz#442438

* Thu Jan 17 2008 Dave Anderson <anderson@redhat.com> - 4.0-5.0.2
- Fix for initialization-time segmentation violation when analyzing
  a vmcore in which the kernel has over-run its kernel stack, 
  corrupting the process thread_info structure, which is used by 
  the crash utility for determining the process cpu.
- Resolves: rbhz#405101

* Thu Jan 17 2008 Dave Anderson <anderson@redhat.com> - 4.0-5.0.1
- Fix for initialization-time failure when analyzing a vmcore of
  an i386-HVM guest that was taken when running on an x86_64 host
- Resolves: rbhz#288691
- Fix for initialization-time segmentation violation when analyzing
  a vmcore in which the kernel has over-run its kernel stack, 
  corrupting the process thread_info structure, which is used by 
  the crash utility for determining the process cpu.
- Resolves: rbhz#405101
- Fix for "mod" command when analyzing ppc64 kernels with 64K pages.
- Resolves: rbhz#414881

* Mon Aug 27 2007 Dave Anderson <anderson@redhat.com> - 4.0-4.6.1
- Fix for "bt" command segmentation violation when run against
  an x86 xen-syms hypervisor.
- Resolves: rhbz#252198

* Fri Jun 22 2007 Dave Anderson <anderson@redhat.com> - 4.0-4.3.1
- Fix for "dev -p" command for ppc64 machines with virtual devices
  and for kernels that don't have the "pci_device" symbol.
- Resolves: rhbz#220929 
- Fix for "crash: cannot resolve "init_task_union" errors due to
  to "__per_cpu_start" and "__per_cpu_end" symbols changing from
  type 'A' to type 'D'.
- Resolves: rhbz#221901 
- Fix for segmentation fault when attempting to read a xen core dump
  from a 6 GB guest.
- Resolves: rhbz#224535 
- Fix for crash session initialization failure indicating "crash:
  cannot read/find cr3 page" in xendumps where the cr3 register
  value in the dumpfile header is overloaded to be able to use
  page directory pages that are greater than 4GB.
- Resolves: rhbz#223454 
- Support for determining the physical base address in FV relocatable
  x86_64 xendump dumpfiles run as xen guests. 
- Resolves: rhbz#233151 
  Create a new crash-devel package for extension modules, which installs
  defs.h in /usr/include/crash. 
- Resolves: rhbz#241045 
  Reasonable backtraces for x86_64.
- Resolves: rhbz#221355

* Fri Dec  1 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.14
- Fix for s390x live system analysis to recognize debuginfo vmlinux
  file that contains an ASCII char adjacent to the Linux version
  string.
- Resolves: rhbz#216973

* Mon Nov 20 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.12
- Fix for ia64 kdump vmcore backtraces when crash was generated
  via INIT switch or due to an MCA exception.
- Resolves: rhbz#216037

* Wed Nov  8 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.11
- Revisited fix for BZ #213929; when crash is run in a small
  terminal window, gdb does line-wrapping that breaks the fix
  for x86_64 backtraces.

* Fri Nov  3 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.10
- Updated crash.patch to match upstream version 4.0-3.9, bumped
  by 1 to differentiate from RHEL4-5 errata version.
- Fixes for x86_64 "bt" command for tasks that have transitioned
  to the IRQ stack from the process stack via hardware interrupt
  or call_softirq entry point, and to the NMI stack from the 
  process stack.
- Resolves: rhbz#213929

* Fri Oct 13 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.7
- Updated crash.patch to match upstream version 4.0-3.7.
- Resolves: rhbz#207296 rhbz#210471

* Wed Sep 13 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.3
- Updated crash.patch to match upstream version 4.0-3.3.
- Support for x86_64 relocatable kernels.  BZ #204557

* Mon Aug  7 2006 Dave Anderson <anderson@redhat.com> - 4.0-3.1
- Updated crash.patch to match upstream version 4.0-3.1.
- Added kdump reference to description.
- Added s390 and s390x to ExclusiveArch list.  BZ #199125
- Removed LKCD v1 pt_regs references for s390/s390x build.
- Removed LKCD v2_v3 pt_regs references for for s390/s390x build.

* Fri Jul 14 2006 Jesse Keating <jkeating@redhat.com> - 4.0-3
- rebuild

* Mon May 15 2006 Dave Anderson <anderson@redhat.com> - 4.0-2.26.4
- Updated crash.patch such that <asm/page.h> is not #include'd
  by s390_dump.c; IBM did not make the file s390[s] only; BZ #192719

* Mon May 15 2006 Dave Anderson <anderson@redhat.com> - 4.0-2.26.3
- Updated crash.patch such that <asm/page.h> is not #include'd
  by vas_crash.h; only ia64 build complained; BZ #191719

* Mon May 15 2006 Dave Anderson <anderson@redhat.com> - 4.0-2.26.2
- Updated crash.patch such that <asm/segment.h> is not #include'd
  by lkcd_x86_trace.c; also for BZ #191719

* Mon May 15 2006 Dave Anderson <anderson@redhat.com> - 4.0-2.26.1
- Updated crash.patch to bring it up to 4.0-2.26, which should 
  address BZ #191719 - "crash fails to build in mock"

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 4.0-2.18.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Wed Jan 04 2006 Dave Anderson <anderson@redhat.com> 4.0-2.18
- Updated source package to crash-4.0.tar.gz, and crash.patch
  to bring it up to 4.0-2.18.

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Mar 03 2005 Dave Anderson <anderson@redhat.com> 3.10-13
- Compiler error- and warning-related fixes for gcc 4 build.
- Update to enhance x86 and x86_64 gdb disassembly output so as to
  symbolically display call targets from kernel module text without
  requiring module debuginfo data.
- Fix hole where an ia64 vmcore could be mistakenly accepted as a
  usable dumpfile on an x86_64 machine, leading eventually to a
  non-related error message.
* Wed Mar 02 2005 Dave Anderson <anderson@redhat.com> 3.10-12
- rebuild (gcc 4)
* Thu Feb 10 2005 Dave Anderson <anderson@redhat.com> 3.10-9
- Updated source package to crash-3.10.tar.gz, containing
  IBM's final ppc64 processor support for RHEL4
- Fixes potential "bt -a" hang on dumpfile where netdump IPI interrupted
  an x86 process while executing the instructions just after it had entered
  the kernel for a syscall, but before calling the handler.  BZ #139437
- Update to handle backtraces in dumpfiles generated on IA64 with the
  INIT switch (functionality intro'd in RHEL3-U5 kernel).  BZ #139429
- Fix for handling ia64 and x86_64 machines booted with maxcpus=1 on
  an SMP kernel.  BZ #139435
- Update to handle backtraces in dumpfiles generated on x86_64 from the
  NMI exception stack (functionality intro'd in RHEL3-U5 kernel).
- "kmem -[sS]" beefed up to more accurately verify slab cache chains
  and report errors found.
- Fix for ia64 INIT switch-generated backtrace handling when
  init_handler_platform() is inlined into ia64_init_handler();
  properly handles both RHEL3 and RHEL4 kernel patches.
  BZ #138350
- Update to enhance ia64 gdb disassembly output so as to
  symbolically display call targets from kernel module
  text without requiring module debuginfo data.

* Wed Jul 14 2004 Dave Anderson <anderson@redhat.com> 3.8-5
- bump release for fc3

* Tue Jul 13 2004 Dave Anderson <anderson@redhat.com> 3.8-4
- Fix for gcc 3.4.x/gdb issue where vmlinux was mistakenly presumed non-debug 

* Fri Jun 25 2004 Dave Anderson <anderson@redhat.com> 3.8-3
- remove (harmless) error message during ia64 diskdump invocation when
  an SMP system gets booted with maxcpus=1
- several 2.6 kernel specific updates

* Thu Jun 17 2004 Dave Anderson <anderson@redhat.com> 3.8-2
- updated source package to crash-3.8.tar.gz 
- diskdump support
- x86_64 processor support 

* Mon Sep 22 2003 Dave Anderson <anderson@redhat.com> 3.7-5
- make bt recovery code start fix-up only upon reaching first faulting frame

* Fri Sep 19 2003 Dave Anderson <anderson@redhat.com> 3.7-4
- fix "bt -e" and bt recovery code to recognize new __KERNEL_CS and DS

* Wed Sep 10 2003 Dave Anderson <anderson@redhat.com> 3.7-3
- patch to recognize per-cpu GDT changes that redefine __KERNEL_CS and DS

* Wed Sep 10 2003 Dave Anderson <anderson@redhat.com> 3.7-2
- patches for netdump active_set determination and slab info gathering 

* Wed Aug 20 2003 Dave Anderson <anderson@redhat.com> 3.7-1
- updated source package to crash-3.7.tar.gz

* Wed Jul 23 2003 Dave Anderson <anderson@redhat.com> 3.6-1
- removed Packager, Distribution, and Vendor tags
- updated source package to crash-3.6.tar.gz 

* Fri Jul 18 2003 Jay Fenlason <fenlason@redhat.com> 3.5-2
- remove ppc from arch list, since it doesn't work with ppc64 kernels
- remove alpha from the arch list since we don't build it any more

* Fri Jul 18 2003 Matt Wilson <msw@redhat.com> 3.5-1
- use %%defattr(-,root,root)

* Tue Jul 15 2003 Jay Fenlason <fenlason@redhat.com>
- Updated spec file as first step in turning this into a real RPM for taroon.
- Wrote man page.
